# OCAPI Hooks for Shop API

The following hooks exist in OCAPI.

## Auth

Auth hooks for Shop API.

***

**dw\.ocapi.shop.auth.afterPOST**

`POST /customers/auth`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPOST</b> (customer : <i>dw.customer.Customer</i>, authRequestType : <i>dw.value.EnumValue</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after the customer has been authenticated. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>customer - the authenticated customer</dd>
    <dd>authRequestType - does the request specify a guest, login or refresh authentication</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.auth.beforePOST**

`POST /customers/auth`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePOST</b> (authorizationHeader : <i>String</i>, authRequestType : <i>dw.value.EnumValue</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before the customer has been authenticated. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>authorizationHeader - the authorization header. Differs depending on the type: 
      <ul>
        <li>guest - no content relevant to the authentication.</li>
        <li>credentials - Base64 encoded username and password. For example Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=. It is possible to extract the username or password: <codeblock>var credentials = authHeader.substr(6); // cut out Basic var base64decoded : String = StringUtils.decodeBase64(credentials, "UTF-8"); var userName : String = base64decoded.split(":")[0]; var password : String = base64decoded.split(":")[1];</codeblock></li>
        <li>refresh - A refresh token, for example Authorization: Bearer XXXXXXXXXXXXXXXXXXXXXXX</li>
        <li>session - no content relevant to the authentication. Authentication based on cookies.</li>
      </ul>
    </dd>
    <dd>authRequestType - does the request specify a guest, login or refresh authentication</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.auth.modifyPOSTResponse**

`POST /customers/auth`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPOSTResponse</b> (customer : <i>dw.customer.Customer</i>, customerResponse : <i>Customer</i>, authRequestType : <i>dw.value.EnumValue</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>customer - the auth customer</dd>
    <dd>customerResponse - customer response object</dd>
    <dd>authRequestType - auth request type enum</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

## Basket

Basket hooks for Shop API.

***

**dw\.ocapi.shop.basket.afterDELETE**

`DELETE /baskets/{basket_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterDELETE</b> (basketId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after removing a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketId - the identifier of the removed basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.afterPATCH**

`PATCH /baskets/{basket_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPATCH</b> (basket : <i>dw.order.Basket</i>, basketInput : <i>Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after updating of the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket that was updated</dd>
    <dd>basketInput - the basket delta containing the desired changes</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.afterPOST**

`POST /baskets`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPOST</b> (basket : <i>dw.order.Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after the basket was created. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the created basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.agent.afterPUT**

`PUT /baskets/{basket_id}/agent`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPUT</b> (basket : <i>dw.order.Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after a put of a basket as an agent basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.agent.beforePUT**

`PUT /baskets/{basket_id}/agent`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePUT</b> (basketId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before the request will be processed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketId - the basket id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.agent.modifyPUTResponse**

`PUT /baskets/{basket_id}/agent`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPUTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.approaching_discounts.beforeGET**

`GET /baskets/{basket_id}/approaching_discounts`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeGET</b> (basketId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before the request will be processed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketId - the basket id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.approaching_discounts.modifyGETResponse**

`GET /baskets/{basket_id}/approaching_discounts`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyGETResponse</b> (approachingDiscountResultResponse : <i>ApproachingDiscountResult</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>approachingDiscountResultResponse - approaching discount result response object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.beforeDELETE**

`DELETE /baskets/{basket_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeDELETE</b> (basket : <i>dw.order.Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before removing a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket to be removed</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.beforeGET**

`GET /baskets/{basket_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeGET</b> (basketId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before the request will be processed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketId - the basket id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.beforePATCH**

`PATCH /baskets/{basket_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePATCH</b> (basket : <i>dw.order.Basket</i>, basketInput : <i>Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before updating of the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket to be updated</dd>
    <dd>basketInput - the basket delta containing the desired changes</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.beforePOST_v2**

`POST /baskets`

<details>
<summary>Method details</summary>

<p>
  <b>beforePOST_v2</b> (basketRequest : <i>Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before the request will be processed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketRequest - the basket request</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.billing_address.afterPUT**

`PUT /baskets/{basket_id}/billing_address`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPUT</b> (basket : <i>dw.order.Basket</i>, billingAddress : <i>OrderAddress</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after setting of the billing address to the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>billingAddress - the billing address that was set to the basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.billing_address.beforePUT**

`PUT /baskets/{basket_id}/billing_address`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePUT</b> (basket : <i>dw.order.Basket</i>, billingAddress : <i>OrderAddress</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before setting of the billing address to the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>billingAddress - the billing address to be set to the basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.billing_address.modifyPUTResponse**

`PUT /baskets/{basket_id}/billing_address`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPUTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, addressRequest : <i>OrderAddress</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>addressRequest - address request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.coupon.afterDELETE**

`DELETE /baskets/{basket_id}/coupons/{coupon_item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterDELETE</b> (basket : <i>dw.order.Basket</i>, couponItemID : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after removing a coupon from a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket the coupon get removed from</dd>
    <dd>couponItemID - the coupon information</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.coupon.afterPOST**

`POST /baskets/{basket_id}/coupons`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPOST</b> (basket : <i>dw.order.Basket</i>, couponItem : <i>CouponItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after adding a coupon to a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket the coupon get added to</dd>
    <dd>couponItem - the coupon information</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.coupon.beforeDELETE**

`DELETE /baskets/{basket_id}/coupons/{coupon_item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeDELETE</b> (basket : <i>dw.order.Basket</i>, couponItemID : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before removing a coupon from a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket the coupon get removed from</dd>
    <dd>couponItemID - the coupon information</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.coupon.beforePOST**

`POST /baskets/{basket_id}/coupons`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePOST</b> (basket : <i>dw.order.Basket</i>, couponItem : <i>CouponItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before adding a coupon to a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket the coupon get added to</dd>
    <dd>couponItem - the coupon information</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.coupon.modifyDELETEResponse**

`DELETE /baskets/{basket_id}/coupons/{coupon_item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyDELETEResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, couponItemId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>couponItemId - coupon item id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.coupon.modifyPOSTResponse**

`POST /baskets/{basket_id}/coupons`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPOSTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, couponRequest : <i>CouponItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>couponRequest - coupon request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.customer.afterPUT**

`PUT /baskets/{basket_id}/customer`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPUT</b> (basket : <i>dw.order.Basket</i>, customerInfo : <i>CustomerInfo</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after setting of customer information for the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>customerInfo - the customer information that were set to the basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.customer.beforePUT**

`PUT /baskets/{basket_id}/customer`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePUT</b> (basket : <i>dw.order.Basket</i>, customerInfo : <i>CustomerInfo</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before setting of customer information for the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>customerInfo - the customer information to be set to the basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.customer.modifyPUTResponse**

`PUT /baskets/{basket_id}/customer`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPUTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, customerRequest : <i>CustomerInfo</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>customerRequest - customer request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.gift_certificate_item.afterDELETE**

`DELETE /baskets/{basket_id}/gift_certificate_items/{gift_certificate_item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterDELETE</b> (basket : <i>dw.order.Basket</i>, giftCertificateItemId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after deleting a gift certificate item from a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>giftCertificateItemId - the id of the deleted gift certificate item</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.gift_certificate_item.afterPATCH**

`PATCH /baskets/{basket_id}/gift_certificate_items/{gift_certificate_item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPATCH</b> (basket : <i>dw.order.Basket</i>, giftCertificateItemId : <i>String</i>, item : <i>GiftCertificateItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after updating a gift certificate item of a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>giftCertificateItemId - the id of the updated gift certificate item</dd>
    <dd>item - the new gift certificate item data</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.gift_certificate_item.afterPOST**

`POST /baskets/{basket_id}/gift_certificate_items`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPOST</b> (basket : <i>dw.order.Basket</i>, item : <i>GiftCertificateItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after adding a gift certificate item to a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>item - the gift certificate item to add</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.gift_certificate_item.beforeDELETE**

`DELETE /baskets/{basket_id}/gift_certificate_items/{gift_certificate_item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeDELETE</b> (basket : <i>dw.order.Basket</i>, giftCertificateItemId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before deleting a gift certificate item from a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>giftCertificateItemId - the id of the gift certificate item to be deleted</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.gift_certificate_item.beforePATCH**

`PATCH /baskets/{basket_id}/gift_certificate_items/{gift_certificate_item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePATCH</b> (basket : <i>dw.order.Basket</i>, giftCertificateItemId : <i>String</i>, item : <i>GiftCertificateItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before updating a gift certificate item of a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>giftCertificateItemId - the id of the gift certificate item to be updated</dd>
    <dd>item - the new gift certificate item data</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.gift_certificate_item.beforePOST**

`POST /baskets/{basket_id}/gift_certificate_items`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePOST</b> (basket : <i>dw.order.Basket</i>, item : <i>GiftCertificateItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before adding a gift certificate item to a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>item - the gift certificate item to add</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.gift_certificate_item.modifyDELETEResponse**

`DELETE /baskets/{basket_id}/gift_certificate_items/{gift_certificate_item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyDELETEResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, giftCertificateItemId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>giftCertificateItemId - the id of the deleted gift certificate item</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.gift_certificate_item.modifyPATCHResponse**

`PATCH /baskets/{basket_id}/gift_certificate_items/{gift_certificate_item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPATCHResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, giftCertificateItemId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>giftCertificateItemId - the id of the updated gift certificate item</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.gift_certificate_item.modifyPOSTResponse**

`POST /baskets/{basket_id}/gift_certificate_items`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPOSTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, certificateItemRequest : <i>GiftCertificateItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>certificateItemRequest - certificateItem request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.item.afterDELETE**

`DELETE /baskets/{basket_id}/items/{item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterDELETE</b> (basket : <i>dw.order.Basket</i>, productItemId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after a basket item is removed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>productItemId - the id of the removed product item</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.item.afterPATCH**

`PATCH /baskets/{basket_id}/items/{item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPATCH</b> (basket : <i>dw.order.Basket</i>, item : <i>ProductItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after updating of the basket's item. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>item - the product item delta containing the desired changes to the product item</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.item.beforeDELETE**

`DELETE /baskets/{basket_id}/items/{item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeDELETE</b> (basket : <i>dw.order.Basket</i>, productItemId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before a basket item is removed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>productItemId - the id of the product item to be removed</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.item.beforePATCH**

`PATCH /baskets/{basket_id}/items/{item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePATCH</b> (basket : <i>dw.order.Basket</i>, item : <i>ProductItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before updating of the basket's item. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>item - the product item delta containing the desired changes to the product item</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.item.modifyDELETEResponse**

`DELETE /baskets/{basket_id}/items/{item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyDELETEResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, productItemId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>productItemId - productItemId request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.item.modifyPATCHResponse**

`PATCH /baskets/{basket_id}/items/{item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPATCHResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, productItemId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>productItemId - productItemId request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.items.afterPATCH**

`PATCH /baskets/{basket_id}/items`

<details>
<summary>Method details</summary>
<p>
<b>afterPATCH</b> (basket: <i>Basket</i>, items: <i>ProductItem[]</i>) : <i>dw.system.Status</i>
</p>
<p>
The function is called by extension point  {@value #extensionPointAfterPatch}  after the patch basket items.
</p>

<div>
<dl>
<dt><b>Parameters:</b></dt>
<dd>basket - the target basket</dd>
<dd>items - productItems array of product items</dd>
</dl>
<dl>
<dt><b>Returns:</b></dt>
<dd>a non-null Status ends the hook execution</dd>
</dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.items.afterPOST**

`POST /baskets/{basket_id}/items`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPOST</b> (basket : <i>dw.order.Basket</i>, items : <i>ProductItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>items - productItems array of product items</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.items.beforePATCH**

`PATCH /baskets/{basket_id}/items`

<details>
<summary>Method details</summary>
<p>
<b>beforePATCH</b> (basket: <i>Basket</i>, items: <i>ProductItem[]</i>) : <i>dw.system.Status</i>
</p>
<p>
The function is called by extension point  {@value #extensionPointBeforePatch}  before the patch basket items.
</p>

<div>
<dl>
<dt><b>Parameters:</b></dt>
<dd>basket - the target basket</dd>
<dd>items - productItems array of product items</dd>
</dl>
<dl>
<dt><b>Returns:</b></dt>
<dd>a non-null Status ends the hook execution</dd>
</dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.items.beforePOST**

`POST /baskets/{basket_id}/items`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePOST</b> (basket : <i>dw.order.Basket</i>, items : <i>ProductItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>items - productItems array of product items</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.items.modifyPATCHResponse**

`PATCH /baskets/{basket_id}/items`

<details>
<summary>Method details</summary>
<p>
<b>modifyPATCHResponse</b> (basket: <i>Basket</i>, productItems: <i>ProductItem[]</i>, basketResponse: <i>Basket</i>) : <i>dw.system.Status</i>
</p>
<p>
The function is called to modify the response by extension point  {@value #extensionPointModifyPATCHResponse} 
 after the patch basket items.
</p>

<div>
<dl>
<dt><b>Parameters:</b></dt>
<dd>basket - the target basket</dd>
<dd>productItems - productItems array of product items</dd>
<dd>basketResponse - basket response object</dd>
</dl>
<dl>
<dt><b>Returns:</b></dt>
<dd>a non-null Status ends the hook execution</dd>
</dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.items.modifyPOSTResponse**

`POST /baskets/{basket_id}/items`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPOSTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, productItems : <i>ProductItem</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>productItems - productItems array of product items</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.modifyGETResponse**

`GET /baskets/{basket_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyGETResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.modifyPATCHResponse**

`PATCH /baskets/{basket_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPATCHResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.modifyPOSTResponse**

`POST /baskets`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPOSTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the created basket</dd>
    <dd>basketResponse - basket response object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.note.afterDELETE**

`DELETE /baskets/{basket_id}/notes/{note_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterDELETE</b> (basket : <i>dw.order.Basket</i>, note : <i>dw.object.Note</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after a note is deleted. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
    <dd>note - the note to be removed</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.note.afterPOST**

`POST /baskets/{basket_id}/notes`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPOST</b> (basketId : <i>String</i>, note : <i>Note</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after a note is added. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
    <dd>note - the note to be added</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.note.beforeDELETE**

`DELETE /baskets/{basket_id}/notes/{note_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeDELETE</b> (basket : <i>dw.order.Basket</i>, note : <i>dw.object.Note</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before a note is deleted. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
    <dd>note - the note to be removed</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.note.beforePOST**

`POST /baskets/{basket_id}/notes`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePOST</b> (basketId : <i>String</i>, note : <i>Note</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before a note is added. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketId - the basket</dd>
    <dd>note - the note to be added</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.note.modifyDELETEResponse**

`DELETE /baskets/{basket_id}/notes/{note_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyDELETEResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, noteId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>noteId - deleted note id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.note.modifyPOSTResponse**

`POST /baskets/{basket_id}/notes`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPOSTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, noteRequest : <i>Note</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>noteRequest - note request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.notes.beforeGET**

`GET /baskets/{basket_id}/notes`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeGET</b> (basketId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before the request will be processed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketId - the basket id the notes result retrieved for.</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.notes.modifyGETResponse_v2**

`GET /baskets/{basket_id}/notes`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyGETResponse_v2</b> (basket : <i>dw.order.Basket</i>, notesResponse : <i>NotesResult</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket the notes result retrieved for.</dd>
    <dd>notesResponse - notes response object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_instrument.afterDELETE**

`DELETE /baskets/{basket_id}/payment_instruments/{payment_instrument_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterDELETE</b> (basket : <i>dw.order.Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
  It is called after the <i>order payment instrument</i> is removed from the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket the payment instrument was removed from</dd>
    <dd>paymentInstrument - the payment instrument to be deleted</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_instrument.afterPATCH**

`PATCH /baskets/{basket_id}/payment_instruments/{payment_instrument_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPATCH</b> (basket : <i>dw.order.Basket</i>, paymentInstrument : <i>dw.order.OrderPaymentInstrument</i>, paymentInstrumentRequest : <i>BasketPaymentInstrumentRequest</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after updating a payment instrument of a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>paymentInstrument - the updated payment instrument</dd>
    <dd>paymentInstrumentRequest - the new payment instrument data</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_instrument.afterPOST**

`POST /baskets/{basket_id}/payment_instruments`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPOST</b> (basket : <i>dw.order.Basket</i>, paymentInstrument : <i>BasketPaymentInstrumentRequest</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after payment instrument adding to a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>paymentInstrument - the payment instrument added to the basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_instrument.beforeDELETE**

`DELETE /baskets/{basket_id}/payment_instruments/{payment_instrument_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeDELETE</b> (basket : <i>dw.order.Basket</i>, delete : <i>dw.order.OrderPaymentInstrument</i>) : <i>dw.system.Status</i> 
</p>
<p>
  It is called before the <i>order payment instrument</i> is removed from the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket to remove the payment instrument from</dd>
    <dd>delete - the order payment instrument document.</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_instrument.beforePATCH**

`PATCH /baskets/{basket_id}/payment_instruments/{payment_instrument_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePATCH</b> (basket : <i>dw.order.Basket</i>, paymentInstrument : <i>dw.order.OrderPaymentInstrument</i>, newPaymentInstrument : <i>BasketPaymentInstrumentRequest</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before updating a payment instrument of a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>paymentInstrument - the payment instrument to be updated</dd>
    <dd>newPaymentInstrument - the new payment instrument data</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_instrument.beforePOST**

`POST /baskets/{basket_id}/payment_instruments`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePOST</b> (basket : <i>dw.order.Basket</i>, paymentInstrument : <i>BasketPaymentInstrumentRequest</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before payment instrument adding to a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>paymentInstrument - the payment instrument to be added to the basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_instrument.modifyDELETEResponse**

`DELETE /baskets/{basket_id}/payment_instruments/{payment_instrument_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyDELETEResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, paymentInstrumentId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>paymentInstrumentRequest - payment instrument id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_instrument.modifyPATCHResponse**

`PATCH /baskets/{basket_id}/payment_instruments/{payment_instrument_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPATCHResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, paymentInstrumentId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>paymentInstrumentRequest - payment instrument id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_instrument.modifyPOSTResponse**

`POST /baskets/{basket_id}/payment_instruments`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPOSTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, paymentInstrumentRequest : <i>BasketPaymentInstrumentRequest</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>paymentInstrumentRequest - payment instrument request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_methods.afterGET**

`GET /baskets/{basket_id}/payment_methods`

<details>  
<summary>Method details</summary>

<p>
  <b>afterGET</b> (basket : <i>dw.order.Basket</i>, paymentMethods : <i>PaymentMethodResult</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Called before returning the list of available payment methods to the customer. Allowing modifications of the result. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
    <dd>paymentMethods - the available payment methods</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_methods.beforeGET**

`GET /baskets/{basket_id}/payment_methods`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeGET</b> (basketId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before the request will be processed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketId - the basket id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.payment_methods.modifyGETResponse_v2**

`GET /baskets/{basket_id}/payment_methods`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyGETResponse_v2</b> (basket : <i>dw.order.Basket</i>, paymentMethodResultResponse : <i>PaymentMethodResult</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket the payment method result retrieved for.</dd>
    <dd>paymentMethodResultResponse - paymentMethodResult response object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.price_adjustment.afterDELETE**

`DELETE /baskets/{basket_id}/price_adjustments/{price_adjustment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterDELETE</b> (basket : <i>dw.order.Basket</i>, priceAdjustmentId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after a custom price adjustment was removed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
    <dd>priceAdjustmentId - the id of the deleted price adjustment</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.price_adjustment.afterPATCH**

`PATCH /baskets/{basket_id}/price_adjustments/{price_adjustment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPATCH</b> (basket : <i>dw.order.Basket</i>, priceAdjustmentId : <i>String</i>, priceAdjustmentWO : <i>PriceAdjustment</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after a custom price adjustment was updated. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
    <dd>priceAdjustmentId - the id of the updated price adjustment</dd>
    <dd>priceAdjustmentWO - the new price adjustment data</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.price_adjustment.afterPOST**

`POST /baskets/{basket_id}/price_adjustments`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPOST</b> (basket : <i>dw.order.Basket</i>, request : <i>PriceAdjustmentRequest</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after a custom price adjustment was added. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
    <dd>request - The request for the price adjustment</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.price_adjustment.beforeDELETE**

`DELETE /baskets/{basket_id}/price_adjustments/{price_adjustment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeDELETE</b> (basket : <i>dw.order.Basket</i>, priceAdjustmentId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before a custom price adjustment is removed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
    <dd>priceAdjustmentId - the id of the price adjustment to be deleted</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.price_adjustment.beforePATCH**

`PATCH /baskets/{basket_id}/price_adjustments/{price_adjustment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePATCH</b> (basket : <i>dw.order.Basket</i>, priceAdjustmentId : <i>String</i>, priceAdjustmentWO : <i>PriceAdjustment</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before a custom price adjustment is updated. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
    <dd>priceAdjustmentId - the id of the price adjustment to be updated</dd>
    <dd>priceAdjustmentWO - the new price adjustment data</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.price_adjustment.beforePOST**

`POST /baskets/{basket_id}/price_adjustments`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePOST</b> (basket : <i>dw.order.Basket</i>, request : <i>PriceAdjustmentRequest</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before a custom price adjustment is added. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
    <dd>request - The request for the price adjustment</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.price_adjustment.modifyDELETEResponse**

`DELETE /baskets/{basket_id}/price_adjustments/{price_adjustment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyDELETEResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, priceAdjustmentId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>priceAdjustmentId - price adjustment id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.price_adjustment.modifyPATCHResponse**

`PATCH /baskets/{basket_id}/price_adjustments/{price_adjustment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPATCHResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, priceAdjustmentId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>priceAdjustmentId - price adjustment id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.price_adjustment.modifyPOSTResponse**

`POST /baskets/{basket_id}/price_adjustments`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPOSTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, priceAdjustmentRequest : <i>PriceAdjustmentRequest</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>priceAdjustmentRequest - price adjustment request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.reference.afterPOST**

`POST /baskets/reference`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPOST</b> (sourceBasket : <i>dw.order.Basket</i>, basket : <i>dw.order.Basket</i>, request : <i>BasketReference</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>sourceBasket - the basket to copy the data from</dd>
    <dd>basket - the created basket</dd>
    <dd>basketReferenceRequest - the basket reference input document</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.reference.beforePOST**

`POST /baskets/reference`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePOST</b> (sourceBasket : <i>dw.order.Basket</i>, request : <i>BasketReference</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>sourceBasket - the basket to copy the data from</dd>
    <dd>basketReferenceRequest - the basket reference input document</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.reference.modifyPOSTResponse**

`POST /baskets/reference`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPOSTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, basketReferenceRequest : <i>BasketReference</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the created basket</dd>
    <dd>basketResponse - the basket response object</dd>
    <dd>basketReferenceRequest - the basket reference input document</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.afterDELETE**

`DELETE /baskets/{basket_id}/shipments/{shipment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterDELETE</b> (basket : <i>dw.order.Basket</i>, shipmentId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Called after the basket's shipment was removed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket that was updated</dd>
    <dd>shipmentId - the id of the deleted shipment</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.afterPATCH**

`PATCH /baskets/{basket_id}/shipments/{shipment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPATCH</b> (basket : <i>dw.order.Basket</i>, shipment : <i>dw.order.Shipment</i>, shipmentInfo : <i>Shipment</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after patching of a shipment for a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the shipment was changed</dd>
    <dd>shipment - the shipment that has been updated</dd>
    <dd>shipmentInfo - the shipment information for the shipment update</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.afterPOST**

`POST /baskets/{basket_id}/shipments`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPOST</b> (basket : <i>dw.order.Basket</i>, shipment : <i>Shipment</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after the creation of a shipment for a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the shipment was created</dd>
    <dd>shipment - the shipment information for the shipment creation</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.beforeDELETE**

`DELETE /baskets/{basket_id}/shipments/{shipment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeDELETE</b> (basket : <i>dw.order.Basket</i>, shipment : <i>dw.order.Shipment</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Called before the basket's shipment is removed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket to be updated</dd>
    <dd>shipment - the shipment to be deleted</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.beforePATCH**

`PATCH /baskets/{basket_id}/shipments/{shipment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePATCH</b> (basket : <i>dw.order.Basket</i>, shipment : <i>dw.order.Shipment</i>, shipmentInfo : <i>Shipment</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before changing of a shipment for a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the shipment will be updated</dd>
    <dd>shipment - the current shipment to be updated</dd>
    <dd>shipmentInfo - the shipment information for the shipment update (update data)</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.beforePOST**

`POST /baskets/{basket_id}/shipments`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePOST</b> (basket : <i>dw.order.Basket</i>, shipment : <i>Shipment</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before the creation of a shipment for a basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the shipment will be created</dd>
    <dd>shipment - the shipment information for the shipment creation</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.modifyDELETEResponse**

`DELETE /baskets/{basket_id}/shipments/{shipment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyDELETEResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, shipmentId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>shipmentId - shipment id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.modifyPATCHResponse**

`PATCH /baskets/{basket_id}/shipments/{shipment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPATCHResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, shipmentId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>shipmentId - shipment id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.modifyPOSTResponse**

`POST /baskets/{basket_id}/shipments`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPOSTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, shipmentRequest : <i>Shipment</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>shipmentRequest - shipment request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.shipping_address.afterPUT**

`PUT /baskets/{basket_id}/shipments/{shipment_id}/shipping_address`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPUT</b> (basket : <i>dw.order.Basket</i>, shipment : <i>dw.order.Shipment</i>, shippingAddress : <i>OrderAddress</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after setting of the shipping address to a certain shipment of the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>shipment - the shipment information for the shipment creation</dd>
    <dd>shippingAddress - the shipping address that was set to the shipment</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.shipping_address.beforePUT**

`PUT /baskets/{basket_id}/shipments/{shipment_id}/shipping_address`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePUT</b> (basket : <i>dw.order.Basket</i>, shipment : <i>dw.order.Shipment</i>, shippingAddress : <i>OrderAddress</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before setting of the shipping address to a certain shipment of the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>shipment - the shipment information for the shipment creation</dd>
    <dd>shippingAddress - the shipping address to be set to the shipment</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.shipping_address.modifyPUTResponse**

`PUT /baskets/{basket_id}/shipments/{shipment_id}/shipping_address`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPUTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, orderAddressRequest : <i>OrderAddress</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>orderAddressRequest - order address request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.shipping_method.afterPUT**

`PUT /baskets/{basket_id}/shipments/{shipment_id}/shipping_method`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPUT</b> (basket : <i>dw.order.Basket</i>, shipment : <i>dw.order.Shipment</i>, shippingMethod : <i>ShippingMethod</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after setting of the shipping method to a certain shipment of the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>shipment - the shipment information for the shipment creation</dd>
    <dd>shippingMethod - the shipping method that was set to the shipment</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.shipping_method.beforePUT**

`PUT /baskets/{basket_id}/shipments/{shipment_id}/shipping_method`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePUT</b> (basket : <i>dw.order.Basket</i>, shipment : <i>dw.order.Shipment</i>, shippingMethod : <i>ShippingMethod</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before setting of the shipping method to a certain shipment of the basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket based on which the order is created</dd>
    <dd>shipment - the shipment information for the shipment creation</dd>
    <dd>shippingMethod - the shipping method to be set to the shipment</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipment.shipping_method.modifyPUTResponse**

`PUT /baskets/{basket_id}/shipments/{shipment_id}/shipping_method`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPUTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>, shippingMethodRequest : <i>ShippingMethod</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
    <dd>shippingMethodRequest - shipping method request object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipments.shipping_methods.beforeGET**

`GET /baskets/{basket_id}/shipments/{shipment_id}/shipping_methods`

<details>  
<summary>Method details</summary>

<p>
  <b>beforeGET</b> (basketId : <i>String</i>, shipmentId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before the request will be processed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketId - the target basket id</dd>
    <dd>shipmentId - the shipment id</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.shipments.shipping_methods.modifyGETResponse_v2**

`GET /baskets/{basket_id}/shipments/{shipment_id}/shipping_methods`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyGETResponse_v2</b> (shipment : <i>dw.order.Shipment</i>, shippingMethodResult : <i>ShippingMethodResult</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>shipment - the shipment the shipping methods result retrieved for.</dd>
    <dd>shippingMethodResult - shipping method result object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.storefront.afterPUT**

`PUT /baskets/{basket_id}/storefront`

<details>  
<summary>Method details</summary>

<p>
  <b>afterPUT</b> (basket : <i>dw.order.Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called after a put of a basket as storefront basket. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.storefront.beforePUT**

`PUT /baskets/{basket_id}/storefront`

<details>  
<summary>Method details</summary>

<p>
  <b>beforePUT</b> (basketId : <i>String</i>) : <i>dw.system.Status</i> 
</p>
<p>
  The function is called before the request will be processed. 
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the basket</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.storefront.modifyPUTResponse**

`PUT /baskets/{basket_id}/storefront`

<details>  
<summary>Method details</summary>

<p>
  <b>modifyPUTResponse</b> (basket : <i>dw.order.Basket</i>, basketResponse : <i>Basket</i>) : <i>dw.system.Status</i> 
</p>
<p>
</p>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basket - the target basket</dd>
    <dd>basketResponse - basket response object</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`DELETE /baskets/{basket_id}/coupons/{coupon_item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`DELETE /baskets/{basket_id}/items/{item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`DELETE /baskets/{basket_id}/notes/{note_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`DELETE /baskets/{basket_id}/payment_instruments/{payment_instrument_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`DELETE /baskets/{basket_id}/price_adjustments/{price_adjustment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`DELETE /baskets/{basket_id}/shipments/{shipment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`GET /baskets/{basket_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`PATCH /baskets/{basket_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`PATCH /baskets/{basket_id}/items/{item_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`PATCH /baskets/{basket_id}/payment_instruments/{payment_instrument_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`PATCH /baskets/{basket_id}/shipments/{shipment_id}`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`POST /baskets`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`POST /baskets/{basket_id}/coupons`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`POST /baskets/{basket_id}/gift_certificate_items`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`PATCH /baskets/{basket_id}/items`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`POST /baskets/{basket_id}/items`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`POST /baskets/{basket_id}/notes`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`POST /baskets/{basket_id}/payment_instruments`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`POST /baskets/{basket_id}/price_adjustments`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`POST /baskets/{basket_id}/shipments`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`POST /orders`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
      flashToRemove = f;
    }
  }
  if (flashToRemove != null) {
    basketResponse.removeFlash(flashToRemove);
  }
};
```

</div>
<div>
  <dl> 
    <dt><b>Parameters:</b></dt>
    <dd>basketResponse - the basket response to be validated, before any OCAPI property selection is applied</dd>
    <dd>duringSubmit - should the basket be checked for submit</dd>
  </dl>
  <dl> 
    <dt><b>Returns:</b></dt>
    <dd>a non-null Status ends the hook execution</dd>
  </dl>
</div>
</details>

***

**dw\.ocapi.shop.basket.validateBasket**

`PUT /baskets/{basket_id}/billing_address`

<details>  
<summary>Method details</summary>

<p>
  <b>validateBasket</b> (basketResponse : <i>Basket</i>, duringSubmit : <i>boolean</i>) : <i>dw.system.Status</i> 
</p>
<p>
  Allows the addition of custom flashes or removal of internal flashes. The presence of a flash indicates that the basket cannot yet be submitted. Parameter <code>duringSubmit</code> indicates the current call is during the basket submit process. Default implementation returns ERROR if duringSubmit and any flash exists.
</p>
<p>
  Example showing addition, listing, and removal of flashes: 
</p>
<div>

```javascript
exports.validateBasket = function(basketResponse, duringSubmit) {
  basketResponse.addFlash({
    type: "MyType",
    message: "My message",
    path: "my_path",
    details: {
      "k1": "v1",
      "k2": "v2"
    }
  });
  var flashToRemove;
  for each(f in basketResponse.flashes) {
    if (f.type == "SomeOtherType") {
[...]
